package com.liang.dao;

import com.liang.entity.SysDictInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysDictInfo)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-25 22:29:46
 */
public interface SysDictInfoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param dictId 主键
     * @return 实例对象
     */
    SysDictInfo queryById(String dictId);

    List<Map<String, String>> queryByCode(String dictCode);

    /**
     * 查询指定行数据
     *
     * @param sysDictInfo 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SysDictInfo> queryAllByLimit(SysDictInfo sysDictInfo, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysDictInfo 查询条件
     * @return 总行数
     */
    long count(SysDictInfo sysDictInfo);

    /**
     * 新增数据
     *
     * @param sysDictInfo 实例对象
     * @return 影响行数
     */
    int insert(SysDictInfo sysDictInfo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysDictInfo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysDictInfo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysDictInfo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysDictInfo> entities);

    /**
     * 修改数据
     *
     * @param sysDictInfo 实例对象
     * @return 影响行数
     */
    int update(SysDictInfo sysDictInfo);

    /**
     * 通过主键删除数据
     *
     * @param dictId 主键
     * @return 影响行数
     */
    int deleteById(String dictId);

    /**
     * 获取枚举公共方法
     *
     * @param dictCode
     * @return
     */
    List<Map<String, String>> getDictByCode(String dictCode);
}

